/*
 * $Id: macro.e,v 1.3 2001/08/03 15:50:48 cssbz Exp $
 */
/*---------------------------------------------------------------------------
function expand(macro_str, para_str1, para_str2, .., para_strN)
  Expands 'macro_str' by substituting 'para_strI' for "?I" and returns the 
  resultant string (ref.: Edward Yung, M.Sc. thesis, `89, vol.2).
---------------------------------------------------------------------------*/

func macro {
  auto i, j, l, m, n, c, s;
  s = "";
  l = (m = $1)#;
  shift;
  i = 1;
  while (i <= l) {
    for (j = i; j <= l && m[j] != '?'; j++);
    if (i != j) s = s // substr(m, i, j - 1);
    if (j <= l) {
      j++;
      n = (c = (j > l) ? '?' : m[j]) - '0';
      s = s // ((1 <= n && n <= $#) ? $[n] : c);
    }
    i = j + 1;
  }
  return s;
}
